Attribute VB_Name = "Module1"
Option Explicit

Private m_Singleton As SingletonClass
Private m_SingletonCreationOk As Boolean
' Return a reference to the Singleton.
Public Property Get Singleton() As SingletonClass
    ' See if it already exists.
    If m_Singleton Is Nothing Then
        ' Flag that this instantiation is ok.
        m_SingletonCreationOk = True
        Set m_Singleton = New SingletonClass
        m_SingletonCreationOk = False
    End If

    Set Singleton = m_Singleton
End Property

' Indicate whether it is ok to create the
' Singleton now.
Public Function SingletonCreationOk() As Boolean
    SingletonCreationOk = m_SingletonCreationOk
End Function

